# nng_http_req_alloc(3http) Manual Page

## NAME

nng_http_req_alloc - allocate HTTP request structure

## SYNOPSIS

    #include <nng/nng.h>
    #include <nng/supplemental/http/http.h>

    int nng_http_req_alloc(nng_http_req **reqp, const nng_url *url);

## DESCRIPTION

The `nng_http_req_alloc()` function allocates a new HTTP request structure and stores a pointer to it in reqp. The request will be initialized to perform an HTTP/1.1 `GET` operation using the URL specified in url.

| It is possible to specify `NULL` for the URL. In this case the URI for the request must be specified by a subsequent call to `nng_http_req_set_uri()`.

## RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

## ERRORS

`NNG_ENOMEM` | Insufficient free memory exists to allocate a message.
`NNG_ENOTSUP` | HTTP support not configured.

## SEE ALSO

nng_http_conn_read_req(3http), nng_http_conn_write_req(3http), nng_http_req_add_header(3http), nng_http_req_copy_data(3http), nng_http_req_del_header(3http), nng_http_req_free(3http), nng_http_req_get_header(3http), nng_http_req_get_method(3http), nng_http_req_get_uri(3http), nng_http_req_get_version(3http), nng_http_req_reset(3http), nng_http_req_set_data(3http), nng_http_req_set_method(3http), nng_http_req_set_uri(3http), nng_http_req_set_version(3http), nng_http_res_alloc(3http), nng_url_parse(3) nng_strerror(3), nng(7)